<!DOCTYPE style-sheet PUBLIC "-//James Clark//DTD DSSSL Style Sheet//EN" [
<!ENTITY docbook.dsl PUBLIC "-//Norman Walsh//DOCUMENT DocBook Print Stylesheet//EN" CDATA dsssl>
]>
<style-sheet>

<style-specification id="print" use="docbook">
<style-specification-body> 

    (declare-characteristic preserve-sdata?
	      "UNREGISTERED::James Clark//Characteristic::preserve-sdata?"
	      #f)

    (define %two-side% #f)
    (define %section-autolabel% #t)
    (define %visual-acuity% "normal")
    ;;(define %visual-acuity% "presbyopic")
    (define %paper-type% "A4")

    (define %generate-book-titlepage% #t)
    (define %generate-book-toc% #t)
    (define ($generate-chapter-toc$) #f)  ;; never generate a chapter TOC in books
    (define %generate-article-titlepage% #t)
    (define %generate-article-toc% #t)      ;; make TOC

    (define %admon-graphics% #t)
    (define %admon-graphics-path% "images/")
    (define ($admon-graphic$ #!optional (nd (current-node)))
      (cond ((equal? (gi nd) (normalize "tip"))
	     (string-append %admon-graphics-path% "tip."
			    %graphic-default-extension%))
	    ((equal? (gi nd) (normalize "note"))
	     (string-append %admon-graphics-path% "note."
			    %graphic-default-extension%))
	    ((equal? (gi nd) (normalize "important"))
	     (string-append %admon-graphics-path% "important."
			    %graphic-default-extension%))
	    ((equal? (gi nd) (normalize "caution"))
	     (string-append %admon-graphics-path% "caution."
	                    %graphic-default-extension%))
	    ((equal? (gi nd) (normalize "warning"))
	     (string-append %admon-graphics-path% "warning." 
                            %graphic-default-extension%))
	    (else (error (string-append (gi nd) " is not an admonition.")))))

    (define %graphic-default-extension% "png")

;;(define (BULLTREAT bullfcn ilevel override mark)
;;  (cond 
;;   (override (bullfcn override ilevel))
;;   (mark (bullfcn mark ilevel))
;;   (else (bullfcn "bullet" ilevel))))
;;   ;;(else (bullfcn "box" ilevel))))
;;   ;;(else (bullfcn "checkbox" ilevel))))
;;   ;;(else (bullfcn "check" ilevel))))
;;   ;;(else (bullfcn "checkedbox" ilevel))))
;;   ;;(else (bullfcn "dash" ilevel))))
;;   ;;(else (bullfcn "none" ilevel))))

    (define %left-margin% 5pi)
    (define %right-margin% 5pi)
    (define %body-start-indent% 0pi)
    (define %body-font-family% "Computer-Modern")
    ;;(define %mono-font-family% "Computer-Modern-Typewriter")
     (define %mono-font-family% "Courier-New")
    (define %title-font-family% "Computer-Modern-Sans");
     (define %admon-font-family% "Helvetica");
    (define %guilabel-font-family% "Computer-Modern-Sans");
     
</style-specification-body>
</style-specification>

<external-specification id="docbook" document="docbook.dsl">
</style-sheet>
