<?php
// (C) 2002 Marco Pratesi <marco@pgmarket.net>

include ("../config.inc.php");
include ("../common.inc.php");
require_login();
require_priv("admin");
include ($CFG["libdir"] . "admin_import_data_files.inc.php");

$DOC_TITLE = "Data_Imports_Management";
include ("header.php");

if ($_SERVER["REQUEST_METHOD"] == "GET") {
	$mode = nvl($_GET["mode"], "");
}
if ($_SERVER["REQUEST_METHOD"] == "POST") {
	$mode = nvl($_POST["mode"], "");
}

$file_uploaded = nvl($_FILES["userfile"]["tmp_name"], "") == "none" || nvl($_FILES["userfile"]["tmp_name"], "") == "";	// "" --> Opera 5

switch (nvl($mode)) {
	case "categories":
	case "categories_i18n":
	case "brands":
	case "iva":
	case "colors":
	case "colors_i18n":
	case "products":
	case "products_i18n":
	case "products_categories":
	case "products_colors":
	case "user_discounts":
	case "zones":
	case "zones_i18n":
	case "delivery_costs":
	case "users":
	case "orders_states":
		print_import_form("import_" . $mode);
		break;

	case "import_categories":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_categories();
			if ($CFG["layersmenu_cached"]) {
				refresh_cache();
			}
		}
		break;

	case "import_categories_i18n":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_categories_i18n();
			if ($CFG["layersmenu_cached"]) {
				refresh_cache();
			}
		}
		break;

	case "import_brands":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_brands();
		}
		break;

	case "import_iva":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_iva();
		}
		break;

	case "import_colors":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_colors();
		}
		break;

	case "import_colors_i18n":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_colors_i18n();
		}
		break;

	case "import_products":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_products();
		}
		break;

	case "import_products_i18n":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_products_i18n();
		}
		break;

	case "import_products_categories":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_products_categories();
		}
		break;

	case "import_products_colors":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_products_colors();
		}
		break;

	case "import_user_discounts":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_user_discounts();
		}
		break;

	case "import_zones":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_zones();
		}
		break;

	case "import_zones_i18n":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_zones_i18n();
		}
		break;

	case "import_delivery_costs":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_delivery_costs();
		}
		break;

	case "import_users":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_users();
		}
		break;

	case "import_orders_states":
		if ($file_uploaded) {
			print_import_form($mode);
		} else {
			import_orders_states();
		}
		break;

	default:
		$PGM_SESSION["goback"]["request_uri"] = stripsid(me() . "?" . $_SERVER["QUERY_STRING"]);
		show_import_template();
		break;
}

include ("footer.php");

pgm_session_close($PGM_SESSION, $session_name);

/* *******************************************************************
 * FUNCTIONS
 ****************************************************************** */

function show_import_template() {
	global $CFG;

	$t = new Template();
	$t->set_file("page", "templates/import.ihtml");
	include ($CFG["localelangdir"] . "global-common.inc.php");
	include ($CFG["localelangdir"] . "global-admin.inc.php");
	$t->set_block("page", "brand_used_import", "brand_used_import_blck");
	$t->set_var("brand_used_import_blck", "");
	if ($CFG["brand_used"]) {
		$t->parse("brand_used_import_blck", "brand_used_import", true);
	}
	$t->set_block("page", "iva_used_import", "iva_used_import_blck");
	$t->set_var("iva_used_import_blck", "");
	if ($CFG["iva_used"]) {
		$t->parse("iva_used_import_blck", "iva_used_import", true);
	}
	$t->set_block("page", "color_used_import", "color_used_import_blck");
	$t->set_var("color_used_import_blck", "");
	$t->set_block("page", "color_used_import2", "color_used_import2_blck");
	$t->set_var("color_used_import2_blck", "");
	if ($CFG["color_used"]) {
		$t->parse("color_used_import_blck", "color_used_import", true);
		$t->parse("color_used_import2_blck", "color_used_import2", true);
	}
	$t->set_block("page", "user_discount_used_import", "user_discount_used_import_blck");
	$t->set_var("user_discount_used_import_blck", "");
	if ($CFG["user_discount_used"]) {
		$t->parse("user_discount_used_import_blck", "user_discount_used_import", true);
	}
	$t->set_block("page", "delivery_used_import", "delivery_used_import_blck");
	$t->set_var("delivery_used_import_blck", "");
	if ($CFG["delivery_used"]) {
		$t->parse("delivery_used_import_blck", "delivery_used_import", true);
	}
	$t->pparse("out", "page");
}

?>
