<?php
// (C) 2002 Marco Pratesi <marco@pgmarket.net>

include ("../config.inc.php");
include ("../common.inc.php");
require_login();
require_priv("admin");
include ($CFG["libdir"] . "admin_import_data_files.inc.php");

$DOC_TITLE = "Data_Imports_Management";
include ("header.php");

if ($_SERVER["REQUEST_METHOD"] == "GET") {
	$mode = nvl($_GET["mode"], "");
}
if ($_SERVER["REQUEST_METHOD"] == "POST") {
	$mode = nvl($_POST["mode"], "");
}

$file_uploaded = nvl($_FILES["userfile"]["tmp_name"], "") == "none" || nvl($_FILES["userfile"]["tmp_name"], "") == "";	// "" --> Opera 5

switch (nvl($mode)) {
	case "import_categories":
		import_categories(false);
		if ($CFG["layersmenu_cached"]) {
			refresh_cache();
		}
		break;

	case "import_categories_i18n":
		import_categories_i18n(false);
		if ($CFG["layersmenu_cached"]) {
			refresh_cache();
		}
		break;

	case "import_brands":
		import_brands(false);
		break;

	case "import_iva":
		import_iva(false);
		break;

	case "import_colors":
		import_colors(false);
		break;

	case "import_colors_i18n":
		import_colors_i18n(false);
		break;

	case "import_products":
		import_products(false);
		break;

	case "import_products_i18n":
		import_products_i18n(false);
		break;

	case "import_products_categories":
		import_products_categories(false);
		break;

	case "import_products_colors":
		import_products_colors(false);
		break;

	case "import_user_discounts":
		import_user_discounts(false);
		break;

	case "import_zones":
		import_zones(false);
		break;

	case "import_zones_i18n":
		import_zones_i18n(false);
		break;

	case "import_delivery_costs":
		import_delivery_costs(false);
		break;

	case "import_users":
		import_users(false);
		break;

	case "import_orders_states":
		import_orders_states(false);
		break;

	default:
		$PGM_SESSION["goback"]["request_uri"] = stripsid(me() . "?" . $_SERVER["QUERY_STRING"]);
		show_import_uploaded_template();
		break;
}

include ("footer.php");

pgm_session_close($PGM_SESSION, $session_name);

/* *******************************************************************
 * FUNCTIONS
 ****************************************************************** */

function show_import_uploaded_template() {
	global $CFG;

	$t = new Template();
	$t->set_file("page", "templates/import_uploaded.ihtml");
	include ($CFG["localelangdir"] . "global-common.inc.php");
	include ($CFG["localelangdir"] . "global-admin.inc.php");
	$t->set_block("page", "brand_used_import", "brand_used_import_blck");
	$t->set_var("brand_used_import_blck", "");
	if ($CFG["brand_used"]) {
		$t->parse("brand_used_import_blck", "brand_used_import", true);
	}
	$t->set_block("page", "iva_used_import", "iva_used_import_blck");
	$t->set_var("iva_used_import_blck", "");
	if ($CFG["iva_used"]) {
		$t->parse("iva_used_import_blck", "iva_used_import", true);
	}
	$t->set_block("page", "color_used_import", "color_used_import_blck");
	$t->set_var("color_used_import_blck", "");
	$t->set_block("page", "color_used_import2", "color_used_import2_blck");
	$t->set_var("color_used_import2_blck", "");
	if ($CFG["color_used"]) {
		$t->parse("color_used_import_blck", "color_used_import", true);
		$t->parse("color_used_import2_blck", "color_used_import2", true);
	}
	$t->set_block("page", "user_discount_used_import", "user_discount_used_import_blck");
	$t->set_var("user_discount_used_import_blck", "");
	if ($CFG["user_discount_used"]) {
		$t->parse("user_discount_used_import_blck", "user_discount_used_import", true);
	}
	$t->set_block("page", "delivery_used_import", "delivery_used_import_blck");
	$t->set_var("delivery_used_import_blck", "");
	if ($CFG["delivery_used"]) {
		$t->parse("delivery_used_import_blck", "delivery_used_import", true);
	}
	$t->pparse("out", "page");
}

?>
