<?php
// (C) 2001-2002 Marco Pratesi <marco@pgmarket.net>
// (C) 2000-2001 Fabio Molinari <fabio.m@mclink.it>

include ("../config.inc.php");
include ("../common.inc.php");
require_login();
require_priv("admin");

$DOC_TITLE = "Sync-Images_Import";
include ("header.php");

if ($_SERVER["REQUEST_METHOD"] == "GET") {
	$mode = nvl($_GET["mode"], "");
}
if ($_SERVER["REQUEST_METHOD"] == "POST") {
	$mode = nvl($_POST["mode"], "");
}

switch (nvl($mode)) {
	case "update_impimg":
		if (nvl($_FILES["userfile"]["tmp_name"], "") == "none" || nvl($_FILES["userfile"]["tmp_name"], "") == "") {	// "" --> Opera 5
			print_sync_import_images_form();
		} else {
			sync_import_images();
		}
		break;

	default:
		print_sync_import_images_form();
		break;
}

include ("footer.php");

pgm_session_close($PGM_SESSION, $session_name);

/* *******************************************************************
 * FUNCTIONS
 ****************************************************************** */

/**
* Prepares an import form to synchronize images and thumbs using an archive file to be uploaded
* @return void
*/
function print_sync_import_images_form() {
	global $CFG, $ME;

	$frm["submit_caption"] = "Import_Images_Button_Label";
	$frm["newmode"] = "update_impimg";

	$t = new Template();
	$t->set_file("page", "templates/data_import_form.ihtml");
	include ($CFG["localelangdir"] . "global-common.inc.php");
	include ($CFG["localelangdir"] . "global-admin.inc.php");
	$t->set_var("ME", $ME);
	$t->set_var(array(
		"frm_title"		=> "",
		"frm_newmode"		=> $frm["newmode"],
		"max_file_size_import"	=> $CFG["max_file_size_import"],
		"frm_submit_caption"	=> $t->get_var($frm["submit_caption"]) . " (.tar.gz, .tgz, .zip)"
	));
	$t->pparse("out", "page");
}

/**
* Synchronizes images and thumbs using the ones provided in an uploaded compressed archive
* @return void
*/
function sync_import_images() {
	global $_FILES;
	global $PGM_SESSION;
	global $CFG, $ME;
	include ($CFG["globalerror"]);

	$qid = new PGM_Sql();
	$errormsg = "";

	// Let's unzip the file with images into tempdir ...
	$tmpdir = $CFG["productsdir"] . "tmp/";
	system ($CFG["rmrf"] . " " . $tmpdir, $result);
	mkdir ($tmpdir, 0777);
	system ("unzip -qq " . $_FILES["userfile"]["tmp_name"] . " -d " . $tmpdir, $result);
	system ("gzip -dc " . $_FILES["userfile"]["tmp_name"] . " | tar xf - -C " . $tmpdir, $result);
	// Let's manage all files in the tempdir
	$handle = opendir ($tmpdir);
//echo "Directory handle: $handle\n";
	while ($file = readdir ($handle)) {
		if ($file != "." && $file != "..") {
		$size = getimagesize ($tmpdir . $file);
		switch ($size[2]) {
			case 1 :
				$type = "gif";
				break;
			case 2 :
				$type = "jpg";
				break;
			case 3 :
				$type = "png";
				break;
			default :
				$type = "";
				$errormsg .= "<li> " . $file . ": " . $unsupported_image_type;
		}
		$product_id = strtok($file, '.');
		if ($product_id != "") {
			$qid->query("SELECT imagetype, thumbtype FROM products WHERE id = '$product_id'");
			if ($qid->num_rows() == 0) {
				$errormsg .= "<li> " . $file . ": " . $no_products_with_such_id;
			} else {
				$qid->next_record();
			}
		}
		if ($type != "" && $product_id != "" && $qid->num_rows() > 0) {
			if ($file != ereg_replace ("thumb", "", $file)) {	// it is a thumb
				$upload_thumb_name = $CFG["productsdir"] . $product_id . ".thumb." . $type;
				if (!copy($tmpdir . $file, $upload_thumb_name)) {
					$errormsg .= "<li> " . $thumb_upload_failed;
				} else {
					// Note: This function is not implemented on Windows platforms.
					chmod ($upload_thumb_name, 0644);
					$oldtype = $qid->f("thumbtype");
					$old_thumb_name = $CFG["productsdir"] . $product_id . ".thumb." . $oldtype;
					if ($old_thumb_name != $upload_thumb_name && file_exists ($old_thumb_name)) {
/*
						if ($CFG["unix"]) {
*/
							// Note: This function may not work on Windows systems.
							unlink ($old_thumb_name);
/*
						} else {
							// FIXME: in this case we should check safe_mode and open_basedir to check
							// if it is possible to remove the product image and, if it is not possible,
							// issue an error message!!!
							system ($CFG["rmf"] . " $old_thumb_name", $result);
						}
*/
					}
					if (!$CFG["images_on_file_system"]) {
						$thumbdata = "";
						if (isset($upload_thumb_name) && file_exists($upload_thumb_name)) {
							$fd = fopen ($upload_thumb_name, "rb");
							$contents = fread ($fd, filesize ($upload_thumb_name));
							fclose ($fd);
							$thumbdata = base64_encode($contents);
							$qid = new PGM_Sql("
								UPDATE products SET thumbdata = '$thumbdata'
								WHERE id = '$product_id'
							");
/*
							if ($CFG["unix"]) {
*/
								// Note: This function may not work on Windows systems.
								unlink ($upload_thumb_name);
/*
							} else {
								system ($CFG["rmf"] . " $upload_thumb_name", $result);
							}
*/
						}
					}
					$qid->query("
						UPDATE products SET
							 thumbtype = '$type'
							,thumbwidth = '$size[0]'
							,thumbheight = '$size[1]'
						WHERE id = '$product_id'
					");
				}
			} else {	// it is a full-size image
				$upload_name = $CFG["productsdir"] . $product_id . "." . $type;
				if (!copy($tmpdir . $file, $upload_name)) {
					$errormsg .= "<li> " . $image_upload_failed;
				} else {
					// Note: This function is not implemented on Windows platforms.
					chmod ($upload_name, 0644);
					$oldtype = $qid->f("imagetype");
					$old_name = $CFG["productsdir"] . $product_id . "." . $oldtype;
					if ($old_name != $upload_name && file_exists ($old_name)) {
/*
						if ($CFG["unix"]) {
*/
							// Note: This function may not work on Windows systems.
							unlink ($old_name);
/*
						} else {
							system ($CFG["rmf"] . " $old_name", $result);
						}
*/
					}
					if (!$CFG["images_on_file_system"]) {
						$imagedata = "";
						if (isset($upload_name) && file_exists($upload_name)) {
							$fd = fopen ($upload_name, "rb");
							$contents = fread ($fd, filesize ($upload_name));
							fclose ($fd);
							$imagedata = base64_encode($contents);
							$qid = new PGM_Sql("
								UPDATE products SET imagedata = '$imagedata'
								WHERE id = '$product_id'
							");
/*
							if ($CFG["unix"]) {
*/
								// Note: This function may not work on Windows systems.
								unlink ($upload_name);
/*
							} else {
								system ($CFG["rmf"] . " $upload_name", $result);
							}
*/
						}
					}
					$qid->query("
						UPDATE products SET
							 imagetype = '$type'
							,imagewidth = '$size[0]'
							,imageheight = '$size[1]'
						WHERE id = '$product_id'
					");
				}
			}
		}
		}
	}
	closedir($handle); 

	// Let's remove the temporary directory ...
	system ($CFG["rmrf"] . " " . $tmpdir, $result);

	// The End
	include ($CFG["dirroot"] . "form_header.php");
	$t = new Template();
	$t->set_file("page", "templates/data_import_end.ihtml");
	include ($CFG["localelangdir"] . "global-common.inc.php");
	include ($CFG["localelangdir"] . "global-admin.inc.php");
	$t->set_var("ME", $ME);
	$t->set_var("backurl", $PGM_SESSION["goback"]["request_uri"]);
	$t->pparse("out", "page");
}

?>
